//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 06: OpenMp
//
//  Description: Sort using openMP. Bubble Sort. Serial Version. Check for solution
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc ompSort01-3.c -o ompSort01-3 -fopenmp -O2
Executing:	./ompSort01-3

Output in my Laptop:
0 0 16331 21720 32534 43513 48959 65535

real	0m20.345s
user	0m20.329s
sys	0m0.016s

*/
//************************************************************


// *******************************************************************
//#pragma GCC optimize("O3","unroll-loops","omit-frame-pointer","inline")
//#pragma GCC option("arch=native","tune=native","no-zero-upper")
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>


// Array Size
#define N          100000

unsigned short int A[N] ;

// ***************************************
unsigned long createArray( unsigned short int *A )
{
for (unsigned int i=0 ; i < N ; i++ )
	A[i] = rand() % 65536 ;
}


// ***************************************
void BubbleSort(unsigned short int *A)
{

#pragma omp parallel for 
for( unsigned int j = 0 ; j < N-1 ; j++ ) {
char c = 1 ;
for( unsigned int i = 0 ; i < N-1 ; i++ )
#pragma omp critical
{
	if ( A[i] > A[i+1] ) {
		unsigned short tmp = A[i] ;
		A[i]=A[i+1] ;
		A[i+1]=tmp ;
		c=0;
		}
}
	if (c) return ;
	}
}


// ***************************************
int main()
{

createArray(A) ;
BubbleSort(A) ;
printf( "%hu %hu %hu %hu ",  A[0], A[1], A[N/4], A[N/3] ) ;
printf( "%hu %hu %hu %hu\n", A[N/2], A[2*N/3], A[3*N/4], A[N-1] ) ;
return 0 ;
}
